<?php 

require ('system/core.php');

if ($userId && isset($_POST['purse']) && isset($_POST['amount']) && isset($_POST['method'])) {
    $purse = $_POST['purse'];
    $amount = round($_POST['amount'], 2); 
    $method = $_POST['method']; 
    
    if (!$amount || $amount > $user['coins']) {
        $json['status'] = 'error';
        $json['msg'] = 'У вас не хватает коинов для вывода этой суммы!';
    }
    
    elseif (empty($purse)) {
        $json['status'] = 'error';
        $json['msg'] = 'Вы не указали номер кошелька';
    }
    
    elseif ($amount < 50) {
        $json['status'] = 'error';
        $json['msg'] = 'Минимальная сумма вывода 50 рублей.';
    }
    
    else {
        $description = 'Вывод через ' . $method;
        $stmt = $db->prepare('INSERT INTO `payments` (userId, coins, description, purse, paytype, status, time) VALUES (?, ?, ?, ?, ?, ?, ?)');
        $stmt->execute(array($userId, '-' . $amount, $description, $purse, $method, 'wait', time()));
        
        $smtp = $db->prepare("UPDATE users SET coins = coins - ? WHERE id = ? LIMIT 1"); 
        $smtp->execute(array($amount, $userId)); 
        
        $smtp = $db->prepare("UPDATE bank SET deposit = deposit - ?"); 
        $smtp->execute(array($amount)); 
        
        $json['status'] = 'success';
        $json['balance'] = round($user['coins'] - $amount, 2);
    }
    
    die(json_encode($json)); 
}

if (empty($_SESSION['lastgame']))
    $_SESSION['lastgame'] = 0;

$gamelast = 'system/tmp/gamelast.dat';
$timelast = 'system/tmp/timelast.dat';
$timethis = 'system/tmp/timethis.dat';
$betlist = 'system/tmp/betlist.dat';

$json = array(); 
$bets = array();

$types = array(1 => 'blue', 2 => 'green', 3 => 'red', 4 => 'yellow'); 

function getWin($array_rates, $bank = 0, $percent = 30) 
{
    global $_BANK; 
    $bet = array(1 => 2, 2 => 3, 3 => 5, 4 => 50);
    
    if (!$array_rates) {
        return mt_rand(1, mt_rand(2, mt_rand(2, 4))); 
    }
    
    $sd = array(1 => 1, 2 => 2, 3 => 3, 4 => 4); 
    $arr = array(); 
    
    foreach($array_rates AS $uid => $data) {
        for($s = 1; $s <= 4; $s++) {
            if (!empty($data['bet'][$s])) $sd[$s] += ($data['bet'][$s] * $bet[$s]);
            
            if (empty($data['bet'][$s])) {
                $arr[] = $s; 
            }
            
            elseif ($_BANK['available'] > ($data['bet'][$s] * $bet[$s])) {
                $arr[] = $s; 
            }
        }
    }
    
    if (count($arr) == 0) {
        asort($sd);
        $keys = array_keys($sd);
        
        return $keys[0];
    }
    
    $win = $arr[mt_rand(0, count($arr) - 1)]; 
    
    if ($win == 4) {
        $win = $arr[mt_rand(0, count($arr) - 1)]; 
    }
    
    return $win;
}

if (!is_file($gamelast)) {
    @file_put_contents($gamelast, json_encode(array())); 
}

$lastGames = json_decode(@file_get_contents($gamelast), 1); 

if (!is_file($betlist)) {
    @file_put_contents($betlist, json_encode($bets = array())); 
}

else {
    $bets = json_decode(file_get_contents($betlist), 1);
}

if (is_file($timelast) && filemtime($timelast) <= (time() - 35)) {
    @unlink($timelast); 
    @unlink($timethis); 
}

if (!empty($_POST['bet']) && !empty($_POST['type']) && !empty($user['id'])) {
    $coins = abs((int) $_POST['bet']); 
    $type = (int) $_POST['type']; 
    
    
    if ($coins < 5) {
        $json['status'] = 'error'; 
        $json['msg'] = 'Минимальная ставка 5 коинов!';
    }
    
    elseif ($coins <= $user['coins']) {
        $smtp = $db->prepare("UPDATE users SET coins = coins - ? WHERE id = " . $user['id']);
        $smtp->execute(array($coins));
        
        $smtp = $db->prepare("INSERT INTO `tour_rates` (`userId`, `coins`, `type`, `time`) VALUES (?, ?, ?, ?)");
        $smtp->execute(array($user['id'], $coins, $type, time()));
        
        if (!empty($bets[$userId]['bet'][$type])) {
            $bets[$userId]['bet'][$type] += $coins; 
        }
        
        else {
            $bets[$userId]['bet'][$type] = $coins;
        }
        
        $bets[$userId]['photo'] = $user['photo']; 
        $bets[$userId]['first_name'] = $user['first_name']; 
        $bets[$userId]['last_name'] = $user['last_name']; 
        $bets[$userId]['profile'] = $user['profile']; 
        
        @file_put_contents($betlist, json_encode($bets));
        $json['status'] = 'success'; 
        $json['balance'] = round($user['coins'] - $coins, 2); 
    }
    
    elseif ($coins > $user['coins']) {
        $json['status'] = 'error'; 
        $json['msg'] = 'У вас не достаточно средств!';
    }
    
    $json['bets'] = $bets; 
    
    die(json_encode($json)); 
}

$margin[1] = array(4979, 4739, 4199, 3959, 3779);
$margin[2] = array(4019, 4799, 4619, 4319, 3839, 4499, 4439);
$margin[3] = array(4859, 4678, 4378, 4078, 3898, 4559);
$margin[4] = array(4919, 4259, 4139);

$margin[1] = array(7199, 7319, 7559, 7799, 7979); 
$margin[2] = array(6959, 7139, 7259, 7439, 7739); 
$margin[3] = array(6899, 7079, 7379, 7679, 7859); 
$margin[4] = array(6719, 6839, 7499, 7619, 8279); 

//$win = mt_rand(1, mt_rand(2, mt_rand(2, 4))); 

//$rand = $margin[$win][0];

if (!is_file($timelast)) {
    file_put_contents($timelast, 539); 
}

$last = (filemtime($timelast) + 30);
$winlast = file_get_contents($timelast);

$sleep = 1;
$timeend = time() + $sleep;

while(time() < $timeend && empty($json)) 
{
    if (is_file($timethis) && (filemtime($timethis) + 10) <= time()) {
        @unlink($timethis); 
    }
    
    if ($_SESSION['lastgame'] < time() && $last <= time()) {
        if (!is_file($timethis)) {
            @unlink($timelast);
            @unlink($betlist);
            
            $win = getWin($bets, $_BANK['available'], 0); 
            $rand = $margin[$win][mt_rand(0, count($margin[$win]) - 1)];
            
            file_put_contents($timelast, $rand); 
            file_put_contents($timethis, $rand);  
            $json['win'] = $rand;   
            
            $winCoinsAll = 0; 
            $loseCoinsAll = 0; 
            $rateCoinsAll = 0; 
            foreach($bets AS $us => $value) {
                $winCoins = 0; 
                foreach($value['bet'] AS $type => $coins) {
                    $rateCoinsAll += $coins; 
                    
                    if ($win == $type) {
                        $winCoins += ($coins * $perWin[$type]); 
                    } else {
                        $loseCoinsAll += $coins; 
                    }
                }
                $winCoinsAll += $winCoins; 
                $db->query("UPDATE users SET coins = coins + '" . $winCoins . "' WHERE id = '$us' LIMIT 1");
            }   
            
            if ($rateCoinsAll > 0) {
                $free = ($loseCoinsAll / 100); 
                $percent = ($loseCoinsAll / 100 * $_BANK['percent']); 
                $_BANK['available'] = ($_BANK['available'] + $rateCoinsAll) - $winCoinsAll - $percent - $free;
                $_BANK['deposit'] = ($_BANK['deposit'] - $rateCoinsAll) + $winCoinsAll;
                
                $db->query("UPDATE bank SET 
                                available = '$_BANK[available]', 
                                bank = bank + '$percent', 
                                deposit = '$_BANK[deposit]', 
                                free = free + '$free'"); 
                
                $smtp = $db->prepare("INSERT INTO `tour` (`win`, `coins_win`, `coins_lose`, `time`) VALUES (?, ?, ?, ?)");
                $smtp->execute(array($win, $winCoinsAll, $loseCoinsAll, time()));
                $uid = $db->lastInsertId();
                
                $counters['tour'] += 1;
                
                $db->query("UPDATE tour_rates SET tourId = '$uid', result = '$win' WHERE tourId = '0'");                 
                $db->query("UPDATE tour_rates SET tourId = '$uid', result = '$win' WHERE tourId = '0'");                 
            }

            if (count($lastGames) >= 8) {
                array_shift($lastGames);
            }
            
            $lastGames[] = $win; 
            @unlink($gamelast);
            file_put_contents($gamelast, json_encode($lastGames)); 
        }
        
        else {
            $json['win'] = file_get_contents($timethis);
        }
        
        if (!empty($json['win'])) {
            $_SESSION['lastgame'] = (time() + 25);
        }
    }
    
    if(!empty($json)) sleep(1);
}

$json['bank'] = $_BANK['available']; 
$json['bets'] = $bets; 
$json['counters'] = $counters; 

$lastGames = json_decode(@file_get_contents($gamelast), 1); 
if (count($lastGames) >= 1) {
    $json['gamelast'] = $lastGames[count($lastGames) - 1];
}

if ($userId) {
    $json['balance'] = round($user['coins'], 2); 
}

if (empty($json['win']))
    $json['last'] = (fileatime($timelast) + 30 - time()) * 1000;
else 
    $json['last'] = 0; 

die(json_encode($json)); 