<?php 
if ($level < 2) {
    die('Access denied');
}

if (!empty($_GET['transfer']) && !empty($_GET['status'])) {
    if (preg_match('#^success|error$#', $_GET['status'])) {
        $smtp = $db->prepare("UPDATE `payments` SET `status` = ? WHERE uid = ? LIMIT 1"); 
        $smtp->execute(array($_GET['status'], $_GET['transfer']));
    }
}

$sid = $_SESSION['sid'] = mt_rand(1, 1000); 
?>
<div class="page">
  <div class="nav-menu">
    <div class="nav-menu-title">
      Админка
    </div>
    <div class="nav-menu-left">
      <a href="/">&larr; Назад к игре</a>
    </div>
  </div>
  
  <div class="rtl">
    <div class="rtl-users">
      <div class="title"><i class="flaticon-people"></i> Пользователи</div>
      <div class="rtl-list">Зарегистрированно<span><?php echo $counters['users']; ?></span></div>
      <div class="rtl-list">Заблокированные<span>0</span></div>
      <div class="rtl-list">Онлайн<span><?php echo $counters['online']; ?></span></div>
    </div>
    
    <div class="rtl-info">
      <div class="title"><i class="flaticon-withdrawal"></i> Информация</div>
      <div class="rtl-list">Отчисления в банк <span><?php echo $_BANK['percent']; ?>%</span></div>
      <div class="rtl-list">Игровой баланс<span><?php echo round($_BANK['available'], 2); ?>р.</span></div>
      <div class="rtl-list">Депозиты<span><?php echo round($_BANK['deposit'], 2); ?>р.</span></div>
    </div>
    
    <div class="rtl-free">
      <div class="title"><i class="flaticon-ruble"></i> Бесплатные коины</div>
      <h2><?php echo round($_BANK['free'], 2); ?>р.</h2>
    </div>
    
    <div class="rtl-out">
      <div class="title"><i class="flaticon-ruble"></i> Заказано на вывод</div>
      <h2>0р.</h2>
    </div>
    
    <div class="rtl-bank">
      <div class="title"><i class="flaticon-ruble"></i> Заработок</div>
      <h2><?php echo round($_BANK['bank'], 2); ?>р.</h2>
    </div>
  </div>
  
  <?php 
  $smtp = $db->prepare("SELECT * FROM payments WHERE status = ? AND coins < ? ORDER BY uid ASC");
  $smtp->execute(array('wait', 0)); 
  
  $data = array(); 
  foreach($smtp->fetchAll() AS $post) 
  {
      $smtp = $db->prepare("SELECT * FROM users WHERE id = ? LIMIT 1");
      $smtp->execute(array($post['userId'])); 
      $profile = $smtp->fetch(); 
      
      $data[] = array(
          'uid' => $post['uid'], 
          'description' => '<a target="_blank" href="' . $profile['profile'] . '">' . $profile['first_name'] . ' ' . $profile['last_name'] . '</a> / ' 
                            . $post['paytype'] . ' / ' . $post['purse'], 
          'coins' => ($post['coins'] > 0 ? '<span class="blue">+' . $post['coins'] . 'р</span>' : '<span class="red">' . $post['coins'] . 'р</span>'), 
          'time' => strTime($post['time']),
          'status' => '<a class="btn btn-success" href="?transfer=' . $post['uid'] . '&sid=' . $sid . '&status=success">Готово</a>
                       <a class="btn btn-danger" href="?transfer=' . $post['uid'] . '&sid=' . $sid . '&status=error">Отклонено</a>',
      );
  }
  
  if (count($data) > 0) {
  ?>
  <div class="post">
    <table cellpadding="0" cellspacing="0">
      <tr>
        <td>№</td>
        <td>Игрок</td>
        <td>Сумма</td>
        <td>Время</td>
        <td></td>
      </tr>
      
      <?php foreach($data AS $item) { ?>
      <tr>
        <td><?php echo $item['uid']; ?></td>
        <td><?php echo $item['description']; ?></td>
        <td><?php echo $item['coins']; ?></td>
        <td><?php echo $item['time']; ?></td>
        <td><?php echo $item['status']; ?></td>
      </tr>
      <? } ?>
    </table>
  </div>     
  <? 
  }
?>
</div>